<?php

  ///////////////////////////////////////////////////////////////////////////////////////////////
  //
  // Function definitions for printing the results page
  // --------------------------------------------------
  //
  ///////////////////////////////////////////////////////////////////////////////////////////////

  // The page navigator
function printNavigate($startRange, $num_rows) {

  // Collect the form values
  global $params_in, $pulsar_name,	$data_type,
    $raj,	$decj,$radius, $from_day,	$from_month, $from_year,
    $to_day, $to_month, $to_year, $state, $cals;
	
  if (isset($params)) {
    $params_str = array2urlstring("params", $params_in);
  }
		
  $num_pages = ceil($num_rows/MAX_DISPLAY_ROWS);
	
  $startPage = ($startRange-1)/MAX_DISPLAY_ROWS;
	
  $startPageRange = floor($startPage / MAX_DISPLAY_PAGES) * MAX_DISPLAY_PAGES;
	
  // Print the previous button
  if ($startPageRange > 0) {
    $prevStartRange = ($startPageRange - 1)*MAX_DISPLAY_ROWS + 1;
    $prevEndRange = $prevStartRange + MAX_DISPLAY_ROWS - 1;
    echo "<a href=\"$PHP_SELF?startRange=$prevStartRange&endRange=$prevEndRange&$params_str&cals=$cals&pulsar_name=$pulsar_name&data_type=$data_type&raj=$raj&decj=$decj&radius=$radius&from_day=$from_day&from_month=$from_month&from_year=$from_year&to_day=$to_day&to_month=$to_month&to_year=$to_year&state=$state\"><< Prev 10</a> &nbsp;\n";
  }
	
  for ($i=$startPageRange; $i < $num_pages && $i - $startPageRange <= MAX_DISPLAY_PAGES; $i++) {
    $start = $i*MAX_DISPLAY_ROWS + 1;
    $end = $start + MAX_DISPLAY_ROWS - 1;
		
    if ($end > $num_rows) {
      $end = $num_rows;
    }
		
    if ($startRange == $start) {
      echo "<b>".($i+1)."</b> &nbsp;\n";
    }
    // When the page index has reached the maximum range, print the next button
    else if ($i - $startPageRange == MAX_DISPLAY_PAGES ) {
      echo " <a href=\"$PHP_SELF?startRange=$start&endRange=$end&$params_str&cals=$cals&pulsar_name=$pulsar_name&data_type=$data_type&raj=$raj&decj=$decj&radius=$radius&from_day=$from_day&from_month=$from_month&from_year=$from_year&to_day=$to_day&to_month=$to_month&to_year=$to_year&state=$state\">Next 10 >></a> \n";
		
    }
    else {
      echo " <a href=\"$PHP_SELF?startRange=$start&endRange=$end&$params_str&cals=$cals&pulsar_name=$pulsar_name&data_type=$data_type&raj=$raj&decj=$decj&radius=$radius&from_day=$from_day&from_month=$from_month&from_year=$from_year&to_day=$to_day&to_month=$to_month&to_year=$to_year&state=$state\">".($i+1)."</a> &nbsp;\n";
    }
  }
	
  }

///////////////////////////////////////////////////////

function showTable($startRange, $endRange, $heading, $all_results, $params, $cals, $cals_within_mins) {
  global $state, $cart_items, $obs_cals;
	
  $link = db_connect();

  // Printing results in HTML
  echo "<table cellpadding=\"5\">\n";

  print_table_header($params);

  if (!isset($params)) {
    echo "No params were selected. Please select at least one.<br>\n";
  }
	
  $index = $startRange;
	
  // For each row in the observations results, print it out as a table
  // and append any matching cals if requested
  // 
  // obs_cals is a hash table with key = the index of the observation
  // and value = an array of cal results
  for ($i=$startRange; ($i < count($all_results) && $index <= $endRange); $i++) {

    if(($params[$i]!="data_loc")&&($params[$i]!="file_size_bytes")){

      $row_html_unchecked = "\t<td class=\"result_row\">
					<input id=\"chkSelect-$i\"  type=\"checkbox\" name=\"selected_obs[]\" value=\"$i\" />
					<span class=\"glyph\" id=\"spaToggle-$i\"></span>
					</td>\n";
	
      $row_html_checked = "\t<td class=\"result_row\">
					<input id=\"chkSelect-$i\" type=\"checkbox\" name=\"selected_obs[]\" value=\"$i\" checked=\"true\" />
					<span class=\"glyph\" id=\"spaToggle-$i\"></span>
					</td>\n";

      $line = $all_results[$i];
		
      // Print the checkbox column
      if ($state == 'cart') {
	if (in_array($i, $cart_items)) {
	  if ($index % 2 == 0) {
	    echo "<tbody class=\"even\">\n";
	  }
	  else {
	    echo "<tbody class=\"odd\">\n";
	  }
	  echo "\t<tr>\n";
	  echo $row_html_checked;

	  // Makes the values of array the keys (index)
	  // Guaranteed that values are unique so it's OK
	  //$flipped_cart = array_flip($cart_items);
				
	  //$cart_index = $flipped_cart[$i];
	}
	else {
	  continue;
	}
      }
      else {			
	if ($index % 2 == 0) {
	  echo "<tbody class=\"even\">\n";
	}
	else {
	  echo "<tbody class=\"odd\">\n";
	}
	  	
	echo "\t<tr>\n";

	if (in_array($i, $cart_items)) {
	  echo $row_html_checked;
	}
			
	else {
	  echo $row_html_unchecked;
	}
      }
		
      // Query for cals
      $all_cals = array();
		
      if (isset($cals) && $cals != "") {

	$num_params = count($params);
			
	//	$all_cals = query_cals($line['src_name'], $line['MJD'], $line['data_type'], $cals_within_mins);
	$all_cals = query_cals($line['pathname'], $cals_within_mins);
			
	// Set the obs_cals array
	if (count($obs_cals) == 0) {
	  $obs_cals = array($index => $all_cals);
	}
	else {
	  array_push($obs_cals, $all_cals);
	}
			
	//echo "\t</tr>\n";
      }
		
		
      ///////////////////
      // Display the row
      echo "\t<td class=\"result_row\" align=\"right\">".($index+1)."</td>\n";	
		
				
      foreach ($params as $param) {
	if (eregi("raj_", $param) || eregi("decj_", $param)) {
	  continue;
	}

	print_param($line, $param);

	echo "</td>\n";
      }
      //print_r($params);
		
      //     print_ra_dec($line, $params);
				
      echo "\t</tr>\n";
		
      print_cals_row($all_cals, $params);
			
      // End the row
		
      echo "\t</tbody>\n";

      //echo "Printing obs_cals<br><pre>\n";
      //print_r($obs_cals);
      //echo "</pre>\n";

      $index++;
    }
  }
  echo "</table>\n";
	
  // By now all cals for each observation have been determined, so set the obs_cals session variable
  $_SESSION['obs_cals'] = $obs_cals;
	
  mysql_close($link);
}

///////////////////////////////////////////////////////

function print_cals_row($all_cals, $params) {

  for ($i=0; $i < count($all_cals); $i++) {
		
    $line = $all_cals[$i];
		
    echo "\t\t<tr class=\"result_row\">\n";
    echo "\t\t<td class=\"result_row\" colspan=\"2\">&nbsp;</td>\n";

    foreach ($params as $param) {
      if (eregi("raj_", $param) || eregi("decj_", $param)) {
	continue;
      }

      print_param($line,$param);
    }
    //     print_ra_dec($line, $params);
					
    echo "\t\t</tr>\n";	
  }
}

///////////////////////////////////////////////////////

function print_ra_dec ($result_row, $params) {

  if (in_array('raj_hour,raj_minute,raj_second', $params)) {
    $raj_str = sprintf("%02d",$result_row['raj_hour']).":".sprintf("%02d",$result_row['raj_minute']).":". sprintf("%02.3f",$result_row['raj_second']);
    echo "\t\t<td class=\"result_row\">$raj_str</td>\n";
  }

  if (in_array('decj_degree,decj_minute,decj_second', $params)) {
    $decj_str = sprintf("%02d",$result_row['decj_degree']).":".sprintf("%02d",$result_row['decj_minute']).":". sprintf("%02.3f",$result_row['decj_second']);
    echo "\t\t<td class=\"result_row\">$decj_str</td>\n";
  }		

}

///////////////////////////////////////////////////////

function print_param($result_row, $param) {
  /////// Perform formatting specific to the data ///////

  if ($result_row[$param] == "" ) {
    echo "\t\t<td class=\"result_row\">";
    echo "&nbsp;";
  }
  else {
    switch ($param) {
    case distance:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.6f", $result_row[$param]);
      break;
    case PERIOD:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.16f", $result_row[$param]);
      break;

    case DM:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.5f", $result_row[$param]);
      break;

    case obsfreq:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.3f", $result_row[$param]);
      break;
    case BW:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.3f", $result_row[$param]);
      break;
    case MJD:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.6f", $result_row[$param]);
      break;
    case rajd:
    case decjd:
    case gl:
    case gb:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.6f", $result_row[$param]);
      break;
    case bmaj:
    case bmin:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.3f", $result_row[$param]);
      break;
    case scanlen:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.3f", $result_row[$param]);
      break;
    case NSUB:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%d", $result_row[$param]);
      break;
    case NBIN:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%d", $result_row[$param]);
      break;
    case TSAMP:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%.6f", $result_row[$param]);
      break;
    case NBEAM:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      printf("%d", $result_row[$param]);
      break;
    default:
      echo "\t\t<td class=\"result_row\" align=\"center\">";
      echo $result_row[$param];
    }
  }
}

///////////////////////////////////////////////////////

function print_table_header($params) {

//////////////////////////////////////////
// Initialise the output heading format

  echo "<thead class=\"file-headings\">
	  <tr>
            ";

  echo "<th>&nbsp;</th>"; // Heading for the check-box column
  echo "<th>#</th>";      // Heading for the row-count column

  $flipped_parameters = array_flip($params);
  foreach (array_keys($flipped_parameters) as $key) {
    // loop over each parameter, and do something specific for each one.
    switch($key){
    case distance:
      $header = "Distance"; break;
    case filename:
      $header = "Filename"; break;
    case src_name:
      $header = "Source Name"; break;
    case project_id:
      $header = "Project ID"; break;
    case raj:
      $header = "RA (J2000)"; break;
    case decj:
      $header = "Dec. (J2000)"; break;
    case data_type:
      $header = "Data Type"; break;
    case obsfreq:
      $header = "Frequency [MHz]"; break;
    case bw:
      $header = "Bandwidth [MHz]"; break;
    case scanlen:
      $header = "Scan Length [s]"; break;
    case date:
      $header = "UT Date"; break;
    case ut:
      $header = "UT Time"; break;
    case MJD:
      $header = "MJD"; break;
    case rajd:
      $header = "RA (J2000) [deg]"; break;
    case decjd:
      $header = "Dec. (J2000) [deg]"; break;
    case gl:
      $header = "Gal. Long. [deg]"; break;
    case gb:
      $header = "Gal. Lat. [deg]"; break;
    case BMAJ:
      $header = "BMAJ [deg]"; break;
    case BMIN:
      $header = "BMIN [deg]"; break;
    case BPA:
      $header = "BPA [deg]"; break;
    case dm:
      $header = "D.M."; break;
    case period:
      $header = "Period [s]"; break;
    case nchan:
      $header = "# Channels"; break;
    case npol:
      $header = "# Pol"; break;
    case nbin:
      $header = "# Bins"; break;
    case nsub:
      $header = "# Subints"; break;
    case tsamp:
      $header = "Sample Time [s]"; break;
    case nbits:
      $header = "# Bits / sample"; break;
    case nbeam:
      $header = "# Beams"; break;
    case cnfg:
      $header = "Config."; break;
    case inst:
      $header = "Inst."; break;
    case rcvr:
      $header = "Receiver"; break;
    case hdrver:
      $header = "Header Version"; break;
    case survey:
      $header = "Survey"; break;
    case telescope:
      $header = "Telescope"; break;
    case site:
      $header = "Site"; break;
    case obsrvr:
      $header = "Observers"; break;
    default:
      $header = "&nbsp;"; break;  // this should not be needed -- all options are listed above.
    }
    echo "<th>$header</th>";
  }
  
  echo "  </tr>
	</thead>\n";

}

?>